// To parse this JSON data, do
//
//     final additionalItems = additionalItemsFromJson(jsonString);

import 'package:meta/meta.dart';
import 'dart:convert';

AdditionalItems additionalItemsFromJson(String str) =>
    AdditionalItems.fromJson(json.decode(str));

String additionalItemsToJson(AdditionalItems data) =>
    json.encode(data.toJson());

class AdditionalItems {
  final int id;
  final int bldgapprDetailsId;
  final int classId;
  final String className;
  final String structType;
  final dynamic unitValue;
  final dynamic baseUnitValue;
  final dynamic area;
  final dynamic marketValue;
  final dynamic depreciationRate;
  final dynamic adjustedMarketVal;
  final dynamic amtDepreciation;
  final bool painted;
  final bool secondhand;
  final dynamic paintedUnitval;
  final dynamic secondhandUnitval;
  final String actualUse;

  AdditionalItems({
    required this.id,
    required this.bldgapprDetailsId,
    required this.classId,
    required this.className,
    required this.structType,
    required this.unitValue,
    required this.baseUnitValue,
    required this.area,
    required this.marketValue,
    required this.depreciationRate,
    required this.adjustedMarketVal,
    required this.amtDepreciation,
    required this.painted,
    required this.secondhand,
    required this.paintedUnitval,
    required this.secondhandUnitval,
    required this.actualUse,
  });

  factory AdditionalItems.fromJson(Map<String, dynamic> json) =>
      AdditionalItems(
        id: json["id"],
        bldgapprDetailsId: json["bldgappr_details_id"],
        classId: json["class_id"],
        className: json["class_name"],
        structType: json["struct_type"],
        unitValue: json["unit_value"],
        baseUnitValue: json["base_unit_value"],
        area: json["area"],
        marketValue: json["market_value"],
        depreciationRate: json["depreciation_rate"],
        adjustedMarketVal: json["adjusted_market_val"],
        amtDepreciation: json["amt_depreciation"],
        painted: json["painted"],
        secondhand: json["secondhand"],
        paintedUnitval: json["painted_unitval"],
        secondhandUnitval: json["secondhand_unitval"],
        actualUse: json["actual_use"],
      );

  Map<String, dynamic> toJson() => {
        "id": id,
        "bldgappr_details_id": bldgapprDetailsId,
        "class_id": classId,
        "class_name": className,
        "struct_type": structType,
        "unit_value": unitValue,
        "base_unit_value": baseUnitValue,
        "area": area,
        "market_value": marketValue,
        "depreciation_rate": depreciationRate,
        "adjusted_market_val": adjustedMarketVal,
        "amt_depreciation": amtDepreciation,
        "painted": painted,
        "secondhand": secondhand,
        "painted_unitval": paintedUnitval,
        "secondhand_unitval": secondhandUnitval,
        "actual_use": actualUse,
      };
}
