// To parse this JSON data, do
//
//     final landPropertyOwner = landPropertyOwnerFromJson(jsonString);

import 'dart:convert';

LandPropertyOwner landPropertyOwnerFromJson(String str) =>
    LandPropertyOwner.fromJson(json.decode(str));

String landPropertyOwnerToJson(LandPropertyOwner data) =>
    json.encode(data.toJson());

class LandPropertyOwner {
  final int? id;
  final String? assessedById;
  final String? assessedByName;
  final DateTime? dateCreated;
  final DateTime? dateModified;
  final String? transCode;
  final String? tdn;
  final String? pin;
  final String? cloaNo;
  final DateTime? dated;
  final String? surveyNo;
  final String? lotNo;
  final String? blkNo;
  final String? owner;
  final String? address;
  final String? telno;
  final String? tin;
  final String? adminUser;
  final String? adminAddress;
  final String? adminTelno;
  final String? adminTin;
  final String? faasType;

  LandPropertyOwner({
    this.id,
    this.assessedById,
    this.assessedByName,
    this.dateCreated,
    this.dateModified,
    this.transCode,
    this.tdn,
    this.pin,
    this.cloaNo,
    this.dated,
    this.surveyNo,
    this.lotNo,
    this.blkNo,
    this.owner,
    this.address,
    this.telno,
    this.tin,
    this.adminUser,
    this.adminAddress,
    this.adminTelno,
    this.adminTin,
    this.faasType,
  });

  factory LandPropertyOwner.fromJson(Map<String, dynamic> json) =>
      LandPropertyOwner(
        id: json["id"],
        assessedById: json["assessed_by_id"],
        assessedByName: json["assessed_by_name"],
        dateCreated: json["date_created"] == null
            ? null
            : DateTime.parse(json["date_created"]),
        dateModified: json["date_modified"] == null
            ? null
            : DateTime.parse(json["date_modified"]),
        transCode: json["trans_code"],
        tdn: json["tdn"],
        pin: json["pin"],
        cloaNo: json["cloa_no"],
        dated: json["dated"] == null ? null : DateTime.parse(json["dated"]),
        surveyNo: json["survey_no"],
        lotNo: json["lot_no"],
        blkNo: json["blk_no"],
        owner: json["owner"],
        address: json["address"],
        telno: json["telno"],
        tin: json["tin"],
        adminUser: json["admin_user"],
        adminAddress: json["admin_address"],
        adminTelno: json["admin_telno"],
        adminTin: json["admin_tin"],
        faasType: json["faas_type"],
      );

  Map<String, dynamic> toJson() => {
        "id": id,
        "assessed_by_id": assessedById,
        "assessed_by_name": assessedByName,
        "date_created": dateCreated?.toIso8601String(),
        "date_modified": dateModified?.toIso8601String(),
        "trans_code": transCode,
        "tdn": tdn,
        "pin": pin,
        "cloa_no": cloaNo,
        "dated":
            "${dated!.year.toString().padLeft(4, '0')}-${dated!.month.toString().padLeft(2, '0')}-${dated!.day.toString().padLeft(2, '0')}",
        "survey_no": surveyNo,
        "lot_no": lotNo,
        "blk_no": blkNo,
        "owner": owner,
        "address": address,
        "telno": telno,
        "tin": tin,
        "admin_user": adminUser,
        "admin_address": adminAddress,
        "admin_telno": adminTelno,
        "admin_tin": adminTin,
        "faas_type": faasType,
      };
}
