import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:unit2/bloc/passo/land/land_property_assessment/land_property_assessment_bloc.dart';
import 'package:unit2/screens/passo/Land/add_land/AddPropertyAssessmentModal.dart';
import 'package:unit2/utils/alerts.dart';
import 'package:unit2/widgets/passo/custom_button.dart';

class LandPropertyAssessmentPage extends StatefulWidget {
  Function PrevBtn;
  Function NextBtn;
  LandPropertyAssessmentPage(this.PrevBtn, this.NextBtn);
  @override
  _LandPropertyAssessmentPage createState() => _LandPropertyAssessmentPage();
}

class _LandPropertyAssessmentPage extends State<LandPropertyAssessmentPage> {
  //  double _totalMarketValue(items) {
  //   double total = 0;
  //   items.forEach((row) {
  //     total += double.parse(row);
  //   });
  //   return total;
  // }

  void deleteItem(int itemId) {
    context
        .read<LandPropertyAssessmentBloc>()
        .add(DeleteLandPropertyAssessment(id: itemId));
  }

  @override
  Widget build(BuildContext context) {
    return BlocConsumer<LandPropertyAssessmentBloc,
        LandPropertyAssessmentState>(listener: (context, state) {
      // TODO: implement listener
    }, builder: (context, state) {
      final state = context.watch<LandPropertyAssessmentBloc>().state;
      if (state is LandPropertyAssessmentLoaded) {
        return Column(
          children: [
            Expanded(
                child: SingleChildScrollView(
              child: Padding(
                padding: const EdgeInsets.all(15.0),
                child: Column(
                  children: [
                    Container(
                      margin: const EdgeInsets.only(
                          left: 0, top: 20, right: 0, bottom: 10),
                      child: const Text('PROPERTY ASSESSMENT',
                          style: TextStyle(
                              fontWeight: FontWeight.bold, fontSize: 18),
                          textAlign: TextAlign.left),
                    ),
                    Align(
                      alignment: Alignment.topRight,
                      child: ElevatedButton(
                        style: ElevatedButton.styleFrom(
                          backgroundColor: Colors.red,
                        ),
                        onPressed: () {
                          context
                              .read<LandPropertyAssessmentBloc>()
                              .add(ShowLandPropertyAssessment());
                        },
                        child: Row(
                          mainAxisSize: MainAxisSize.min,
                          children: [
                            const Text('ADD ITEM'), // <-- Text
                            const SizedBox(
                              width: 5,
                            ),
                            const Icon(
                              // <-- Icon
                              Icons.add,
                              size: 24.0,
                            ),
                          ],
                        ),
                      ),
                    ),
                    SingleChildScrollView(
                        scrollDirection: Axis.horizontal,
                        child: DataTable(
                            // ignore: prefer_const_literals_to_create_immutables
                            columns: [
                              const DataColumn(
                                label: Text('Actual Use'),
                              ),
                              const DataColumn(
                                label: Text('Market Value'),
                              ),
                              const DataColumn(
                                label: Text('Assessment Level'),
                              ),
                              const DataColumn(
                                label: Text('Assessed Value'),
                              ),
                              const DataColumn(
                                label: Text('Action'),
                              )
                            ],
                            rows: state.assessment.map((dataRow) {
                              return DataRow(
                                cells: [
                                  DataCell(Text(dataRow.actualUse!)),
                                  DataCell(Text(dataRow.marketval!)),
                                  DataCell(
                                      Text(dataRow.assessmentLevel! + '%')),
                                  DataCell(Text(dataRow.assessedValue!)),
                                  DataCell(Row(
                                    children: [
                                      InkWell(
                                        child: Container(
                                          height: 30,
                                          width: 30,
                                          decoration: BoxDecoration(
                                            shape: BoxShape.circle,
                                            color: Colors.red,
                                          ),
                                          child: Icon(
                                            Icons.delete,
                                            color: Colors.white,
                                            size: 20.0,
                                          ),
                                        ),
                                        onTap: () {
                                          deleteItem(dataRow.id!);
                                        },
                                      ),
                                      SizedBox(
                                        width: 10,
                                      ),
                                      InkWell(
                                        child: Container(
                                          height: 30,
                                          width: 30,
                                          decoration: BoxDecoration(
                                            shape: BoxShape.circle,
                                            color: Colors.red,
                                          ),
                                          child: Icon(
                                            Icons.edit,
                                            color: Colors.white,
                                            size: 20.0,
                                          ),
                                        ),
                                        onTap: () {},
                                      ),
                                    ],
                                  ))
                                ],
                              );
                            }).toList()))
                  ],
                ),
              ),
            )),
            // Padding(
            //   padding: const EdgeInsets.only(left: 20.0, right: 20.0),
            //   child: Row(
            //     mainAxisAlignment: MainAxisAlignment.spaceBetween,
            //     children: [
            //       Text(
            //         'Total',
            //         style: TextStyle(fontWeight: FontWeight.bold, fontSize: 15),
            //       ),
            //       Text(
            //         NumberFormat.currency(locale: 'en-PH', symbol: "₱")
            //             .format('1.0'),
            //         style: TextStyle(fontWeight: FontWeight.bold, fontSize: 15),
            //       )
            //     ],
            //   ),
            // ),
            Padding(
              padding: const EdgeInsets.all(15.0),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                children: [
                  CustomButton(
                    icon: const Icon(Icons.chevron_left_rounded,
                        color: Colors.white),
                    onPressed: () {
                      {
                        widget.PrevBtn();
                      }
                      ;
                    },
                  ),
                  CustomButton(
                    icon: const Icon(Icons.chevron_right_rounded,
                        color: Colors.white),
                    onPressed: () {
                      {
                        widget.NextBtn();
                      }
                      ;
                    },
                  )
                ],
              ),
            ),
          ],
        );
      }
      if (state is LandPropertyAssessmentDeletedState) {
        if (state.success) {
          WidgetsBinding.instance.addPostFrameCallback((_) {
            successAlert(context, "Deletion Successful",
                "Extra item has been deleted successfully", () {
              Navigator.of(context).pop();
              context
                  .read<LandPropertyAssessmentBloc>()
                  .add(const LoadLandPropertyAssessment());
            });
          });
        }
      }
      if (state is ShowAddLandPropertyAssessmentScreen) {
        return ConstrainedBox(
          constraints: BoxConstraints(maxHeight: 1000.0),
          child: AlertDialog(
            insetPadding: EdgeInsets.symmetric(
              horizontal: 20.0,
              vertical: 10.0,
            ),
            title: Text(
              'ADD PROPERTY ASSESSMENT',
              textAlign: TextAlign.center,
            ),
            content: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [Expanded(child: AddPropertyAssessmentModal())],
            ),
          ),
        );
      }
      return Container();
    });
  }
}
